%%
%% SNU Thesis Template for LaTeX (EE/CSE Ȥ  Only - Ȯ )
%%  ܿ  "% " ˻ϸ ٲ ϴ κ ã  ֽϴ.
%% Modified from the Kaist Thesis Template for LaTeX ver. 0.4
%% (This template is largely based on the Kaist Thesis Template.)
%%
%% @author	Min, Byungho mailto:bhmin@meslab.snu.ac.kr
%%
%% @requirements
%%    current distribution of teTeX, fpTeX, MikTeX
%%    + HLaTeX (by ) 0.991 ̻ ֽ
%%      or HPACK (by ȫȣ) 1.0 ̻ ֽ
%%    : detailed information available at http://www.ktug.or.kr
%%

\NeedsTeXFormat{LaTeX2e}[1995/12/01]
\ProvidesClass{snu}
    [2007/2/27 v0.1 Standard SNU Thesis document class]

%% ɼ   boolean 
\newif\if@isDoctor
\newif\if@isKorean
\newif\if@isFinal

%%  ɼ  - doctor|master, korean|english, final|draft
\DeclareOption{doctor} {\@isDoctortrue}
\DeclareOption{master} {\@isDoctorfalse}
\DeclareOption{korean} {\@isKoreantrue}
\DeclareOption{english}{\@isKoreanfalse}
\DeclareOption{final}  {\@isFinaltrue}
\DeclareOption{draft}  {\@isFinalfalse}

%% leqno,fleqn,openbib ɼ ״ report Ŭ 
\DeclareOption{leqno}  {\PassOptionsToClass{leqno}  {report}}
\DeclareOption{fleqn}  {\PassOptionsToClass{fleqn}  {report}}
\DeclareOption{openbib}{\PassOptionsToClass{openbib}{report}}

\ExecuteOptions{doctor,korean,final}         % doctor,korean,final ⺻
\ProcessOptions

%% 10pt,a4paper,onecolumn,oneside ɼ report Ŭ ҷ
\LoadClass[10pt,a4paper,onecolumn,oneside]{report}

\RequirePackage{hfont,ifthen,graphicx,setspace}       % ߰ Ű 

\AtBeginDocument{%                           % \begin{document} Բ 
    \checkparameters                        %   ùٸ 
    \if@isFinal                             % final ɼ Ǿ 
        \makefrontcover \maketitle         % ǥ, ǥ 
        \makeapproval                      % μ, ɻϷ 
    \else \fi }
\AtEndDocument{}                             % \end{document} Բ 

%% ¿   - A4  4 x 6 
\setlength{\topmargin}     {4.6mm}
\setlength{\headheight}    {10mm}
\setlength{\headsep}       {10mm}
\setlength{\oddsidemargin} {11.6mm}
\setlength{\textheight}    {198mm}
\setlength{\textwidth}     {140mm}
\setlength{\footskip}      {12mm}

%% ٰ  (References, Contents(׸, ǥ  ) ٰ  1.3 Ǿ ֽϴ.)
\renewcommand{\baselinestretch}{2.0}

%%   Ǿִ ѱ۷ Ǿִ 
\newcommand{\@korean}{korean}
\newcommand{\@english}{english}
\newcommand{\@textlang}{}                    % ؽƮ ⺻ 
\if@isKorean                                 % korean ɼ Ǿ 
    \let\@textlang\@korean                  % ؽƮ ⺻ ѱ
\else                                        % english ɼ Ǿ 
    \let\@textlang\@english                 % ؽƮ ⺻ 
\fi

%%   Ī
\newcommand{\@snu}{Seoul National University}

%%
%%    
%%

% @command title  
% @options [default: (none)]
% - korean: ѱ | english: 
\renewcommand{\title}[2][korean] {%
    \ifthenelse{\equal{#1}{korean}}%
        {\newcommand{\@titleKor}{#2}}{}%
    \ifthenelse{\equal{#1}{english}}%
        {\newcommand{\@titleEng}{#2}}{}%
}
\@onlypreamble{\title}

% @command author  ̸
% @param family_name, given_name , ̸ ؼ Է
% @options [default: (none)]
% - korean: ѱ̸ | chinese: ѹ̸ | english: ̸
\renewcommand{\author}[4][korean] {%
    \ifthenelse{\equal{#1}{korean}}
        {\newcommand{\@authorKorFN}{#2}
         \newcommand{\@authorKorGN}{#3}       
         \newcommand{\@authorKorGNb}{#4}           
         \newcommand{\@authorKor}{#2\ #3\ #4}}{}%
    \ifthenelse{\equal{#1}{chinese}}
        {\newcommand{\@authorChnFN}{#2}
         \newcommand{\@authorChnGN}{#3}
         \newcommand{\@authorChnGNb}{#4}              
         \newcommand{\@authorChn}{#2\ #3\ #4}}{}%
    \ifthenelse{\equal{#1}{english}}
        {\newcommand{\@authorEngFN}{#2}
         \newcommand{\@authorEngGN}{#3}
         \newcommand{\@authorEngGNb}{#4}         
         \newcommand{\@authorEng}{#2, #3}}{}%
}
\@onlypreamble{\author}

% @command advisor  ̸ ()
% @options [default: major]
% - major:    | coopr:   ( )
\newcommand{\advisor}[5][major]{%
    \ifthenelse{\equal{#1}{major}} {%       %  ̸
        \newcommand{\@advisorMajorKor}{#2} % ѱ̸ 
        \newcommand{\@advisorMajorEng}{#3} % ̸ 
        \newcommand{\@advisorMajorChn}{#4} % ̸ 
        % nosign       
        \ifthenelse{\equal{#5}{nosign}}{}{%
            \newcommand{\@advisorSigned}{\@advisorMajorEng}} }{}%
    \ifthenelse{\equal{#1}{coopr}} {%       %  ̸
        \newcommand{\@advisorCooprKor}{#2} % ѱ̸ 
        \newcommand{\@advisorCooprEng}{#3} % ̸ 
        \newcommand{\@advisorCooprChn}{#4} % ̸ 
        % signed ؾ     
        \ifthenelse{\equal{#5}{signed}}{%
            \newcommand{\@advisorSigned}{\@advisorCooprEng}}{} }{}%
}
\@onlypreamble{\advisor}

% @command department а̸ - Ʒ ǥ  ڵ带 Է
%
% ǻͰ        EECS
%  ܰ뿡  ߰  ֽϴ.

\newcommand{\@degreeCode}{}          %  ڵ
\newcommand{\@degreeName}{}          % 
\newcommand{\@affFullNameKor}{}      % а/ ѱ̸
\newcommand{\@affFullNameEng}{}      % а/ ̸
%\newcommand{\@affFullNameEngCover}{} % а/ ̸(ǥ)
\newcommand{\@deptNameKor}{}
\newcommand{\@deptNameEng}{}
\newcommand{\@divNameKor}{}
\newcommand{\@divNameEng}{}
\newcommand{\@progNameKor}{}
\newcommand{\@progNameEng}{}
\newcommand{\@degreeField}{}
\newcommand{\@degreePrefix}{\ifthenelse{\boolean{@isDoctor}}{D}{M}}
\newcommand{\department}[1] {%
    \ifthenelse{\equal{#1}{EECS}}
        {\renewcommand{\@degreeCode}{\@degreePrefix#1}%
         \renewcommand{\@deptNameKor}{Ѩǻ }%
         \renewcommand{\@deptNameEng}{Electrical Engineering and
                                Computer Science}%
         %\renewcommand{\@divNameKor}{ǻͰ}%
         %\renewcommand{\@divNameEng}{Computer Science and Engineering}
         \renewcommand{\@degreeField}{science}} {}%
% ⿡ EECSó ߰ϸ ˴ϴ.

    \renewcommand{\@affFullNameKor}{%               % а/ ѱ̸
        \ifthenelse{\equal{\@deptNameKor}{}} {}{\@deptNameKor ݻ}%
        \ifthenelse{\equal{\@divNameKor}{}} {}{ \@divNameKor Ρ}%
        \ifthenelse{\equal{\@progNameKor}{}} {}{\@progNameKor }%
    }
    \renewcommand{\@affFullNameEng}{%               % а/ ̸
        \ifthenelse{\equal{\@deptNameEng}{}}
            {\ifthenelse{\equal{\@divNameEng}{}}
                {}{Division of \@divNameEng}}%   % (division)
            {School of \@deptNameEng          % кθ
             \ifthenelse{\equal{\@divNameEng}{}}
                {}{,\ Division of \@divNameEng}} % а + (division)
        \ifthenelse{\equal{\@progNameEng}{}}
            {}{\@progNameEng\ Program}%           % (program)
    }
%    \renewcommand{\@affFullNameEngCover}{%          % а/ ̸
%        \ifthenelse{\equal{\@deptNameEng}{}}       % (ǥμ)
%            {\ifthenelse{\equal{\@divNameEng}{}}
%                {}{Division of \@divNameEng}}%
%            {Department of \@deptNameEng
%             \ifthenelse{\equal{\@divNameEng}{}}
%                {}{%
%                Division of \@divNameEng} }
%        \ifthenelse{\equal{\@progNameEng}{}}
%            {}{\@progNameEng\ Program}%
%    }
    \renewcommand{\@degreeName}{%                       %  ̸
        \ifthenelse{\boolean{@isDoctor}}
            {Doctor of Philosophy} {%                 % ڻ  Ph.D.
            \ifthenelse{\equal{\@degreeField}{science}}
                {Master of Science}{}%               % м M.S.
            \ifthenelse{\equal{\@degreeField}{engineering}}
                {Master of Engineering}{}%           % м M.E.
            \ifthenelse{\equal{\@degreeField}{business}}
                {Master of Business Administration}{}% 濵м M.B.A.
        }
    }
}
\@onlypreamble{\department}

% @command studentid й
\newcommand{\studentid}[1]{\newcommand{\@studentID}{#1}}
\@onlypreamble{\studentid}

% @command referee ɻ ( 3, ڻ 5)
\newcommand{\referee}[2][1] {%
    \ifthenelse{\equal{#1}{1}}{\newcommand{\@refereeChief} {#2}} {}%
    \ifthenelse{\equal{#1}{2}}{\newcommand{\@refereeSecond}{#2}} {}%
    \ifthenelse{\equal{#1}{3}}{\newcommand{\@refereeThird} {#2}} {}%
    \ifthenelse{\equal{#1}{4}}{\newcommand{\@refereeFourth}{#2}} {}%
    \ifthenelse{\equal{#1}{5}}{\newcommand{\@refereeFifth} {#2}} {}%
}
\@onlypreamble{\referee}

% @command approvaldate 
% @param year,month,day ,  Է
\newcommand{\approvaldate}[2] {%
    \newcommand{\@approvalYear}{#1}
    \newcommand{\@approvalMonth}{#2}
}
\@onlypreamble{\approvaldate}

% @command refereedate ɻɻ
% @param year,month,day ,  Է
\newcommand{\refereedate}[2] {%
    \newcommand{\@refereeYear}{#1}
    \newcommand{\@refereeMonth}{#2}
}
\@onlypreamble{\refereedate}

% @command gradyear ⵵
\newcommand{\gradyear}[2]{
    \newcommand{\@gradYear}{#1}
    \newcommand{\@gradMonth}{#2}
}
\@onlypreamble{\gradyear}

% @command keywords Ű
\newcommand{\keywords}[1]{
    \newcommand{\@keywords}{#1}
}
\@onlypreamble{\keywords}

%%
%% ʿ  ߿     --> .  ҿ.
%%
\newcommand{\checkparameters}{%
    \@ifundefined{@titleKor}{%
        \ClassError{snu}{The korean title is not found}{}}{}
    \@ifundefined{@titleEng}{%
        \ClassError{snu}{The english title is not found}{}}{}
    \@ifundefined{@authorKor}{%
        \ClassError{snu}{The korean name of the author is not found}{}}{}
    \@ifundefined{@authorChn}{%
        \ClassError{snu}{The chinese name of the author is not found}{}}{}
    \@ifundefined{@authorEng}{%
        \ClassError{snu}{The english name of the author is not found}{}}{}
    \@ifundefined{@advisorMajorKor}{%
        \ClassError{snu}{The korean name of the major advisor is not found}{}}{}
    \@ifundefined{@advisorMajorEng}{%
        \ClassError{snu}{The english name of the major advisor is not found}{}}{}
}

%%
%% ǥ 
%% б Ģ ٸ    б Ģ ޶ 
%%     .   츸     Ʒ ߰.
%%
\newcommand{\makefrontcover}{%
    \renewcommand{\baselinestretch}{1.3}%
    \thispagestyle{empty} \noindent%
    \begin{minipage}[t][3cm][t]{\textwidth}
        \begin{center}
            \Large
            \if@isDoctor
                 % ܿ  ؾ.
            \else
                 % ܿ  ؾ.
            \fi
        \end{center}
    \end{minipage}\\[0mm]
    \begin{minipage}[t][10cm][t]{\textwidth}
        \begin{center}
            \LARGE  \@titleKor 
            \if@isKorean {}
            \else
            { \\[10pt] \Large \@titleEng}            
            \fi
        \end{center}
    \end{minipage}\\[0mm]
    \begin{minipage}[t][4.5cm][t]{\textwidth}
        \begin{center}
            \Large \@gradYear Ҵ \@gradMonth 
        \end{center}
    \end{minipage}
    \begin{minipage}[t][2cm][b]{\textwidth}
        \begin{center}
            \Large   \\
            \@affFullNameKor \\
            \@authorChnFN\ \ \ \@authorChnGN\ \ \ \@authorChnGNb
        \end{center}
    \end{minipage}\\[0mm]
    \newpage
}

%%
%% ǥ  
%%
\renewcommand{\maketitle}{%
    \renewcommand{\baselinestretch}{1.3}%
    \thispagestyle{empty} \noindent%
    \begin{minipage}[t][3cm][t]{\textwidth}
        \begin{center}
            \Large
            \if@isDoctor
                 % ܿ  ؾ.
            \else
                 % ܿ  ؾ.
            \fi
        \end{center}
    \end{minipage}\\[0mm]
    \begin{minipage}[t][10cm][t]{\textwidth}
        \begin{center}
            \LARGE  \@titleKor 
            \if@isKorean {}
            \else
            { \\[10pt] \Large \@titleEng}
            \fi 
        \end{center}
    \end{minipage}\\[0mm]
    \begin{minipage}[t][4.5cm][t]{\textwidth}
        \begin{center}
            \Large \@gradYear Ҵ \@gradMonth 
        \end{center}
    \end{minipage}
    \begin{minipage}[t][2cm][b]{\textwidth}
        \begin{center}
            \Large   \\
            \@affFullNameKor \\
            \@authorChnFN\ \ \ \@authorChnGN\ \ \ \@authorChnGNb
        \end{center}
    \end{minipage}\\[0mm]
    \newpage
}

%%
%% 
%%
\newcommand{\makeapproval}{%
    \thispagestyle{empty} \noindent
    \parbox[t][1.5cm][t]{\textwidth}{\mbox{}}       % 1.5cm 
    \begin{center}
        \LARGE \@titleKor           %  ѱ
    \end{center}
    \vspace*{10mm}            
    \begin{minipage}[t][8cm][t]{\textwidth}
      \begin{center}
        \Large 
         \@advisorMajorChn\\
        \vspace*{10mm}        
          \ifthenelse{\boolean{@isDoctor}}{}{}\  \\ % ܿ  ؾ.
        \@approvalYear Ҵ \@approvalMonth \\
        \vspace*{10mm}
          \\
        \@affFullNameKor \\
        \@authorChnFN\ \ \ \@authorChnGN\ \ \ \@authorChnGNb\\
        \vspace*{10mm}        
        \@authorChnFN \@authorChnGN \@authorChnGNb \ifthenelse{\boolean{@isDoctor}}{}{}\  \\ % ܿ  ؾ.
        \@refereeYear Ҵ \@refereeMonth 
        \vspace*{10mm}
      \end{center}
    \end{minipage}\\[0mm]
    \begin{minipage}[t][5cm][b]{\textwidth}
    \begin{center}    
        \newcommand{\@nameWidth}{70pt}
        \newcommand{\@refWidth}{50pt}
        \newcommand{\@sealWidth}{40pt}
        \begin{tabular}{crr}
            \@ifundefined{@refereeChief}{}
            {\makebox[\@refWidth][s]{  } & \makebox[\@nameWidth][s]{\@refereeChief} & \makebox[\@sealWidth][r]{()} \\
            \hline}
            \@ifundefined{@refereeSecond}{}
            { \makebox[\@refWidth][s]{   } & \makebox[\@nameWidth][s]{\@refereeSecond} & \makebox[\@sealWidth][r]{()} \\
            \hline}
            \@ifundefined{@refereeThird}{}
            { \makebox[\@refWidth][s]{ } & \makebox[\@nameWidth][s]{\@refereeThird} & \makebox[\@sealWidth][r]{()} \\
            \hline}
            \@ifundefined{@refereeFifth}{}
            { \makebox[\@refWidth][s]{ } & \makebox[\@nameWidth][s]{\@refereeFourth} & \makebox[\@sealWidth][r]{()} \\
            \hline}
            \@ifundefined{@refereeFifth}{}
            { \makebox[\@refWidth][s]{ } & \makebox[\@nameWidth][s]{\@refereeFifth} & \makebox[\@sealWidth][r]{()} \\
            \hline}
        \end{tabular}  
        \end{center} 
    \end{minipage}
    \newpage
}

%%
%% ʷ(abstract) 
%%
\newcounter{pagemarker}                           %  ȣ ӽ 
\newcommand{\@lastPage}{\pageref{paperlastpagelabel}} %    
\renewenvironment{abstract}{%
    \pagenumbering{roman}                        % θ  
    \pagestyle{plain}%
    \newcommand{\@tempbreak}{}                   % \linebreak  
    \let\@tempbreak\linebreak
    \renewcommand{\linebreak}{\ }                % \linebreak ->  ü
    \begin{center}
        \textbf{\LARGE\abstractname}\\ % ʷϸ -> Abstract
    \end{center}
    %⿡ ʷ .
    \addcontentsline{toc}{chapter}{\abstractname}% ʷ (TOC) 
}{  \setcounter{pagemarker}{\value{page}}        %   ȣ 
    \vspace*{10mm}
    \\ \textbf{Keywords}:\ \@keywords
    \\
    \\ \textbf{Student Number}:\ \@studentID
    \addtocounter{pagemarker}{1}                 %  
    \newpage \pagenumbering{arabic}              %  ƶ  
    \let\linebreak\@tempbreak                    % \linebreak  
}

%%
%%  ϰ 
%%
\newcommand{\makecontents}{%            % TOC, LOT, LOF 
    \tableofcontents
    \listoftables
    \listoffigures
}

%%
%% ޺κ ๮  
%% -  ̸ ѱ , ѱ ̸    ȴ.
%%
%%  ̸  ְ  ʴٸ Ʒ ּ ǥõ  ϸ ȴ.
%% ,   \abstracb ؾ Ѵ. (\begin{abstracb} ƴ!)
%%
\newenvironment{abstractb}{%              % ޺κ ๮  ȯ
    \newcommand{\@tempbreak}{}
    \let\@tempbreak\linebreak
    \renewcommand{\linebreak}{\ }      % \linebreak  ٲġ
    \if@isKorean
       \chapter*{Abstract} %Ǵ 'ʷ'̶ ᵵ .
       \addcontentsline{toc}{chapter}{Abstract} 
    \else
        \chapter*{\ \ \ \ } 
       \addcontentsline{toc}{chapter}{ ʷ} % ߰ϴ κ
    \fi
}{  \let\linebreak\@tempbreak          % \linebreak  ǵ
}
%\newcommand{\abstractb}{%                 %  ߰  Ű   ޺κ ๮ 
%    \chapter*{Abstract}
%    \pagestyle{empty}
%}

%%
%%   
%%
\newcommand{\acknowledgement}{%                 %  
    \chapter*{  \ \ }
    \pagestyle{empty}
}

%%
%% ̷¼ 
%%
\newcommand{\curriculumvitae}[1][default]{%     % ̷¼
    \newcommand{\@ccvlang}{#1}
    \ifthenelse{\equal{#1}{default}}            % ƹ ɼ  
        {\let\@ccvlang\@textlang}{}           %   ̷¼ 
    \ifthenelse{\equal{\@ccvlang}{\@korean}}
        {\chapter*{  }}                 % korean  ɼ 
        {\chapter*{Curriculum Vit\ae}}         % english ɼ 
    \pagestyle{empty}
}

%%
%% ̷¼   
%%
    \newenvironment{personaldata}{%            % 
        \begin{list}{}{%
            \setlength{\labelwidth}{70pt}
            \setlength{\leftmargin}{\labelwidth}
            \addtolength{\leftmargin}{\labelsep}
            \setlength{\parsep}{0pt}
            \renewcommand{\makelabel}[1]{\textgt{##1\ \ :\ }}}
        \newcommand{\name}[1]{%               % ̸
            \ifx\@ccvlang\@korean
                \def\@arg{[\hfill]}
            \else
                \def\@arg{[Name\hfill]}
            \fi
            \expandafter\item\@arg ##1}
        \newcommand{\dateofbirth}[3]{%        % 
            \ifx\@ccvlang\@korean
                \def\@arg{[\hfill\hfill\hfill]}
                \expandafter\item\@arg ##1 ##2 ##3
            \else
                \def\@arg{[Date of Birth\hfill]}
                \expandafter\item\@arg \@dateUSenglish{##1}{##2}{##3}
            \fi}
        \newcommand{\birthplace}[1]{%         % 
            \ifx\@ccvlang\@korean
                \def\@arg{[\hfill\hfill]}
            \else
                \def\@arg{[Birthplace\hfill]}
            \fi
            \expandafter\item\@arg ##1}
        \newcommand{\domicile}[1]{%           % 
            \ifx\@ccvlang\@korean
                \def\@arg{[\hfill\hfill]}
            \else
                \def\@arg{[Domicile\hfill]}
            \fi
            \expandafter\item\@arg ##1}
        \newcommand{\address}[1]{%            % ּ
            \ifx\@ccvlang\@korean
                \def\@arg{[\hfill]}
            \else
                \def\@arg{[Address\hfill]}
            \fi
            \expandafter\item\@arg ##1}
        \newcommand{\email}[1]{%              % E-mail
            \ifx\@ccvlang\@korean
                \def\@arg{[E-mail\hfill\hfill]}
            \else
                \def\@arg{[E-mail\hfill]}
            \fi
            \expandafter\item\@arg ##1}
        % ̷¼  ߰ ʵ尡 ʿϸ  Ͽ   .
        % \newcommand{(ʵ)}[1]{%
        %   \ifx\@ccvlang\@korean
        %       \def\@arg{[(ѱʵ)]}
        %   \else
        %       \def\@arg{[(ʵ)]}
        %   \fi
        %   \expandafter\item\@arg ##1}
    }{\end{list}}

    \newenvironment{education}{%               % з
        \vspace*{5mm} \noindent
        \ifx\@ccvlang\@korean
            \begin{center}
                \makebox[2cm][s]{\textbf{\large  }}
            \end{center}
        \else \textbf{\large Educations} \fi
        \begin{list}{}{%
            \setlength{\labelwidth}{90pt}
            \setlength{\leftmargin}{\labelwidth}
            \addtolength{\leftmargin}{\labelsep}
            \setlength{\parsep}{0pt}
            \renewcommand{\makelabel}[1]{\textgt{##1\hfill\ }}}
    }{\end{list}}

    \newenvironment{career}{%                  % 
        \vspace*{5mm} \noindent
        \ifx\@ccvlang\@korean
            \begin{center}
                \makebox[2cm][s]{\textbf{\large  }}
            \end{center}
        \else \textbf{\large Career} \fi
        \begin{list}{}{%
            \setlength{\labelwidth}{90pt}
            \setlength{\leftmargin}{\labelwidth}
            \addtolength{\leftmargin}{\labelsep}
            \setlength{\parsep}{\z@}
            \renewcommand{\makelabel}[1]{\textgt{##1\hfill\ }}}
    }{\end{list}}

    \newcounter{itemnum1}
    \newenvironment{activity}{%                % ȸȰ
        \vspace*{5mm} \noindent
        \ifx\@ccvlang\@korean
            \begin{center}
                \makebox[2cm][s]{\textbf{\large  ȸ Ȱ }}
            \end{center}
        \else \textbf{\large Academic Activities} \fi
        \begin{list}{}{%
            \usecounter{itemnum1}
            \setlength{\labelwidth}{1.5em}
            \setlength{\leftmargin}{\labelwidth}
            \addtolength{\leftmargin}{\labelsep}
            \setlength{\parsep}{\z@}
            \renewcommand{\makelabel}{\textgt{\arabic{itemnum1}.\ }}}
    }{\end{list}}

    \newcounter{itemnum2}
    \newenvironment{publication}{%             % 
        \vspace*{5mm} \noindent
        \ifx\@ccvlang\@korean
            \begin{center}
                \makebox[2cm][s]{\textbf{\large    }}
            \end{center}
        \else \textbf{\large Publications} \fi
        \begin{list}{}{%
            \usecounter{itemnum2}
            \setlength{\labelwidth}{1.5em}
            \setlength{\leftmargin}{\labelwidth}
            \addtolength{\leftmargin}{\labelsep}
            \setlength{\parsep}{\z@}
            \renewcommand{\makelabel}{\textgt{\arabic{itemnum2}.\ }}}
    }{\end{list}}

%%
%%  缳
%%
\renewcommand{\contentsname}{%
    \if@isKorean         \else Contents        \fi}
\renewcommand{\listfigurename}{%
    \if@isKorean     \else List of Figures \fi}
\renewcommand{\listtablename}{%
    \if@isKorean ǥ      \else List of Tables  \fi}
\renewcommand{\bibname}{%
    \if@isKorean     \else References      \fi}

%%
%% \part  - ƿ  ϰ ƹ.   ȣϸ  ߻.
%%
\renewcommand\part{%
    \secdef\@part\@spart}
\def\@part[#1]#2{%
    \ClassError{snu}{The use of \protect\part\space is prohibited.
        \MessageBreak Consider the use of \protect\chapter\space instead}{}
}
\def\@spart#1{%
    \ClassError{snu}{The use of \protect\part\space is prohibited.
        \MessageBreak Consider the use of \protect\chapter\space instead}{}
}

%%
%% \chapter  - report Ŭκ Ͽ Ϻ 
%%
\renewcommand\chapter{%
    \if@openright\cleardoublepage\else\clearpage\fi
%   \thispagestyle{plain}%
    \global\@topnum\z@
    \@afterindentfalse
%   \if@isKorean \parindent\z@ \else \fi % <-- ߰  
    \secdef\@chapter\@schapter}
\def\@chapter[#1]#2{%
    \ifnum \c@secnumdepth >\m@ne
        \refstepcounter{chapter}%
        \typeout{\@chapapp\space\thechapter.}%
        \addcontentsline{toc}{chapter}{%
            \if@isKorean
                \protect\numberline{ \thechapter\ }#1
            \else
                \protect\numberline{\thechapter}#1
            \fi
        }% <--  Ÿ  - 
    \else
        \addcontentsline{toc}{chapter}{#1}%
    \fi
    \chaptermark{#1}%
    \addtocontents{lof}{\protect\addvspace{10\p@}}%
    \addtocontents{lot}{\protect\addvspace{10\p@}}%
    \if@twocolumn
        \@topnewpage[\@makechapterhead{#2}]%
    \else
        \@makechapterhead{#2}%
        \@afterheading%
    \fi
}
\def\@makechapterhead#1{% <-- ü 
    \vspace*{10\p@}
    {\centering \parindent\z@ \LARGE\bfseries
    \ifthenelse{\equal{\@textlang}{korean}}
        {\hspace{1.4ex}\thechapter\hspace{1.4ex}\hspace{2ex}}
        {\thechapter.\hspace{1ex}}
    #1\par}
    \vspace*{20\p@}
}
\def\@schapter#1{%
    \if@twocolumn
        \@topnewpage[\@makeschapterhead{#1}]%
    \else
        \@makeschapterhead{#1}%
        \@afterheading
    \fi}
\def\@makeschapterhead#1{% <-- ü 
    \vspace*{10\p@}
    {\centering \parindent\z@ \LARGE\bfseries #1\par}
    \vspace*{20\p@}
}

%%
%% \tableofcontents  - report Ŭκ Ͽ Ϻ 
%%
\renewcommand\tableofcontents{%
    \if@twocolumn
        \@restonecoltrue\onecolumn
    \else
        \@restonecolfalse
    \fi
    \chapter*{\contentsname
        \@mkboth{\MakeUppercase\contentsname}{\MakeUppercase\contentsname}}%
    \begin{spacing}{1.3} %  ٰ  1.3 
    \pagenumbering{roman}                         % roman ȣ 
    \setcounter{page}{\value{pagemarker}}         % pagemarker  
    \addcontentsline{toc}{chapter}{\contentsname} % (TOC) ߰
    \@starttoc{toc}%
    \if@restonecol\twocolumn\fi
    \newpage \setcounter{pagemarker}{\value{page}}% pagemarker ٽ 
    \pagenumbering{arabic}                        % arabic ȣ 
    \end{spacing}
}

%%
%% \listoftables  - report Ŭκ Ͽ Ϻ 
%%
\renewcommand\listoftables{%
    \if@twocolumn
        \@restonecoltrue\onecolumn
    \else
        \@restonecolfalse
    \fi
    \chapter*{\listtablename}%
    \@mkboth{\MakeUppercase\listtablename}{\MakeUppercase\listtablename}%
    \begin{spacing}{1.3} %  ٰ  1.3     
    \pagenumbering{roman}                         % roman ȣ 
    \setcounter{page}{\value{pagemarker}}         % pagemarker  
    \addcontentsline{toc}{chapter}{\listtablename}% (TOC) ߰
    \@starttoc{lot}%
    \if@restonecol\twocolumn\fi
    \newpage \setcounter{pagemarker}{\value{page}}% pagemarker ٽ 
    \pagenumbering{arabic}                        % arabic ȣ 
    \end{spacing} 
}

%%
%% \listoffigures  - report Ŭκ Ͽ Ϻ 
%%
\renewcommand\listoffigures{%
    \if@twocolumn
        \@restonecoltrue\onecolumn
    \else
        \@restonecolfalse
    \fi
    \chapter*{\listfigurename}%
    \@mkboth{\MakeUppercase\listfigurename}{\MakeUppercase\listfigurename}%
    \begin{spacing}{1.3} %  ٰ  1.3     
    \pagenumbering{roman}                         % roman ȣ 
    \setcounter{page}{\value{pagemarker}}         % pagemarker  
    \addcontentsline{toc}{chapter}{\listfigurename}% (TOC) ߰
    \@starttoc{lof}%
    \if@restonecol\twocolumn\fi
    \newpage \setcounter{pagemarker}{\value{page}}% pagemarker ٽ 
    \pagenumbering{arabic}                        % arabic ȣ 
    \end{spacing}
}

%%
%%    - report Ŭκ Ͽ Ϻ 
%%
\renewcommand*\l@chapter[2]{%
    \ifnum \c@tocdepth >\m@ne
        \addpenalty{-\@highpenalty}%
        \vskip 1.0em \@plus\p@
        \if@isKorean                     % <--  κ
            \setlength\@tempdima{5.0em} % korean  ɼ  5.0em
        \else
            \setlength\@tempdima{1.5em} % english ɼ  1.5em
        \fi
        \begingroup
            \parindent \z@ \rightskip \@pnumwidth
            \parfillskip -\@pnumwidth
            \leavevmode \large \sffamily \bfseries
            \advance\leftskip\@tempdima
            \hskip -\leftskip
            #1\nobreak\hfil \nobreak\hb@xt@\@pnumwidth{\hss #2}\par
            \penalty\@highpenalty
        \endgroup
    \fi}

\if@isKorean % ѱ̸  ġ 
    \renewcommand*\l@section{\@dottedtocline{1}{2.7em}{2.3em}}
    \renewcommand*\l@subsection{\@dottedtocline{2}{5.0em}{3.2em}}
    \renewcommand*\l@subsubsection{\@dottedtocline{3}{8.2em}{4.1em}}
    \renewcommand*\l@paragraph{\@dottedtocline{4}{11.2em}{5em}}
    \renewcommand*\l@subparagraph{\@dottedtocline{5}{13.2em}{6em}}
\else \fi     % ̸  

%%
%% thebibliography ȯ  - report Ŭκ Ͽ Ϻ 
%%

\renewenvironment{thebibliography}[1]{%
    \chapter*{\bibname}%
    \@mkboth{\MakeUppercase\bibname}{\MakeUppercase\bibname}%
    \addcontentsline{toc}{chapter}{\bibname}%
\begin{spacing}{1.3}  %  Refereceκ   1.3 մϴ.
    \list{
    \@biblabel{\@arabic\c@enumiv}}%
        {\settowidth\labelwidth{\@biblabel{#1}}%
         \leftmargin\labelwidth
         \advance\leftmargin\labelsep
         \@openbib@code
         \usecounter{enumiv}%
         \let\p@enumiv\@empty
         \renewcommand\theenumiv{\@arabic\c@enumiv}}%
    \sloppy
    \clubpenalty4000
    \@clubpenalty \clubpenalty
    \widowpenalty4000%
    \sfcode`\.\@m%
}{  \label{paperlastpagelabel}     % <-- ߰ κ:   ġ 
    \def\@noitemerr{\@latex@warning{Empty `thebibliography' environment}}%
    \endlist
\end{spacing}%

}

%%
%% ѱ ¥ ǥ ->  ¥ ǥ
%%
\newcommand{\@dateUSenglish}[3]{%  % ̱ ¥ ǥ
    \newcommand{\@year}{#1}%
    \newcommand{\@month}{#2}%
    \newcommand{\@day}{#3}%
    \ifcase\@month \or
        January \or February \or March \or April \or May \or June \or
        July \or August \or September \or October \or November \or December \fi
    \@day, \@year
}
\newcommand{\@dateBRenglish}[3]{%  %  ¥ ǥ
    \newcommand{\@year}{#1}%
    \newcommand{\@month}{#2}%
    \newcommand{\@day}{#3}%
    \@day\ifcase\@day \or
        st\or nd\or rd\or th\or th\or th\or th\or th\or th\or th\or
        st\or nd\or rd\or th\or th\or th\or th\or th\or th\or th\or
        st\or nd\or rd\or th\or th\or th\or th\or th\or th\or th\or th\fi
    \space\ifcase\@month \or
        January\or February\or March\or April\or May\or June\or
        July\or August\or September\or October\or November\or December\fi,
    \@year
}
